000100 IDENTIFICATION DIVISION.
000200 PROGRAM-ID. GESTFST.
000300 AUTHOR. OBELIX84.
000400
000500*-----------------------------------------------------------------
000600* V1.0 DU 25/11/2019 -
000610* V1.1 DU 27/11/2019 -
000620*      Correction affichage des libelles (manquait un blanc)
000700*-----------------------------------------------------------------
000800*                - GESTION DES FILES STATUS -
000900*                ----------------------------
001000* Appele par call ce sp recoit
001100*     - FN (file name   sur 8 octets)
001200*     - FS (file status sur 2 octets)
001300* et renvoie un return code
001400*     - RC (zone binaire 5 positions signee)
001500*
001600* Il va decortiquer ce file status faire un display du pourquoi
001700* et renvoyer un RC
001800*    - RC=00  OK (cas ou on appelle GESTFST avec FS=00)
001900*    - RC=04  fin de fichier (FS=10 si AT END pas prevu)
002000*    - RC=08  Conditionnelle. A etudier (pas forcement bloquant)
002100*    - RC=12  Bloquante. Erreur I/O par exemple
002200*    - RC=16  Grave. Code FS non prevu
002300*    - RC=20  Interne. Mauvaise programmation de GESTFST...
002400*
002500*-----------------------------------------------------------------
002600* v1.0
002700*     Seuls sont traites les codes normaux
002800*     On peut prevoir une extension aux codes etendus
002900*
003000*-----------------------------------------------------------------
003100
003200 ENVIRONMENT DIVISION.
003300 CONFIGURATION SECTION.
003400*=====================
003500 SOURCE-COMPUTER. PC.
003600 OBJECT-COMPUTER. PC.
003700
003800*-----------------------------------------------------------------
003900
004000 DATA DIVISION.
004100
004200 WORKING-STORAGE SECTION.
004300*=======================
004400 01  FSK.
004500     05 FSK1         PIC X(01).
004600     05 FSK2         PIC X(01).
004700     05 FSK2-BIN REDEFINES FSK2 PIC 9(02) COMP.
004800 01  FSE.
004900     05 FILLER       PIC X(02) VALUE "9/".
005000     05 FSE-COD      PIC 9(03).
005010     05 FILLER       PIC X(01) VALUE SPACES.
005100     05 FSE-LIB      PIC X(38).
005200 01  FSN.
005300     05 FILLER       PIC X(03).
005400     05 FSN-LIB      PIC X(38).
005500 01  TABLE-LIB.
005600  05 L00 PIC X(38) VALUE "NORMAL AUCUNE ERREUR".
005700  05 L02 PIC X(38) VALUE "FICHIER INDEXE CLE EN DOUBLE".
005800  05 L04 PIC X(38) VALUE "LONGUEUR ENREGISTREMENT NON CONFORME".
005900  05 L05 PIC X(38) VALUE "FICHIER OPTIONNEL NON PRESENT A L'OPEN".
006000  05 L07 PIC X(38) VALUE "PROBLEME AU CLOSE".
006100  05 L10 PIC X(38) VALUE "FIN DE FICHIER".
006200  05 L14 PIC X(38) VALUE "FICHIER RELATIF TAILLE DE LA CLE".
006300  05 L21 PIC X(38) VALUE "ERREUR DE SEQUENCE".
006400  05 L22 PIC X(38) VALUE "FICHIER INDEXE PROBLEME DE CLE".
006500  05 L23 PIC X(38) VALUE "READ SUR FICHIER OPTIONNEL ABSENT".
006600  05 L24 PIC X(38) VALUE "PROBLEME DE CLE".
006700  05 L30 PIC X(38) VALUE "ERREUR I/O".
006800  05 L34 PIC X(38) VALUE "ERREUR I/O".
006900  05 L35 PIC X(38) VALUE "OPEN SUR FICHIER OPTIONNEL ABSENT".
007000  05 L37 PIC X(38) VALUE "TYPE D'OPEN NON SUPPORTE".
007100  05 L38 PIC X(38) VALUE "OPEN SUR FICHIER VERROUILLE".
007200  05 L39 PIC X(38) VALUE "CONFLIT ENTRE TAILLE DECLAREE & REELLE".
007300  05 L41 PIC X(38) VALUE "OPEN SUR FICHIER DEJA OUVERT".
007400  05 L42 PIC X(38) VALUE "CLOSE SUR FICHIER DEJA FERME".
007500  05 L43 PIC X(38) VALUE "PROBLEME DE SEQUENCE DES MODES D'ACCES".
007600  05 L44 PIC X(38) VALUE "VIOLATION DES LIMITES".
007700  05 L46 PIC X(38) VALUE "READ SUR ENREGISTREMENT INEXISTANT".
007800  05 L47 PIC X(38) VALUE "READ ET PROBLEME D'OPEN".
007900  05 L48 PIC X(38) VALUE "WRITE ET PROBLEME D'OPEN".
008000  05 L49 PIC X(38) VALUE "REWRITE OU DELETE ET PROBLEME D'OPEN".
008100  05 LXX PIC X(38) VALUE "INCONNU DANS LE MANUEL MICROFCUS COBOL".
008200
008300 LINKAGE SECTION.
008400*===============
008500 01  FN           PIC X(08).
008600 01  FS           PIC X(02).
008700 01  RC           PIC S9(05).
008800
008900 PROCEDURE DIVISION USING FN FS RC.
009000*=================================
009100
009200 DEBUT.
009300     MOVE FS TO FSK.
009400     MOVE 20  TO RC.
009500     EVALUATE FSK1
009600          WHEN "9"   PERFORM TRAITEMENT-EXTENDED
009700          WHEN OTHER PERFORM TRAITEMENT-NORMAL
009800     END-EVALUATE.
009900     GO TO RETOUR.
010000
010100*-----------------------------------------------------------------
010200*    Traitement normal (different de 9 en  1ere position du fs)
010300*-----------------------------------------------------------------
010400 TRAITEMENT-NORMAL.
010500     MOVE FSK TO FSN.
010600     MOVE 20  TO RC.
010700     EVALUATE FSK
010800          WHEN "00"  MOVE  0 TO RC MOVE L00 TO FSN-LIB
010900          WHEN "02"  MOVE  8 TO RC MOVE L02 TO FSN-LIB
011000          WHEN "04"  MOVE  8 TO RC MOVE L04 TO FSN-LIB
011100          WHEN "05"  MOVE  8 TO RC MOVE L05 TO FSN-LIB
011200          WHEN "07"  MOVE  8 TO RC MOVE L07 TO FSN-LIB
011300          WHEN "10"  MOVE  4 TO RC MOVE L10 TO FSN-LIB
011400          WHEN "14"  MOVE  8 TO RC MOVE L14 TO FSN-LIB
011500          WHEN "21"  MOVE  8 TO RC MOVE L21 TO FSN-LIB
011600          WHEN "23"  MOVE  8 TO RC MOVE L22 TO FSN-LIB
011700          WHEN "24"  MOVE  8 TO RC MOVE L23 TO FSN-LIB
011800          WHEN "30"  MOVE 12 TO RC MOVE L30 TO FSN-LIB
011900          WHEN "34"  MOVE 12 TO RC MOVE L34 TO FSN-LIB
012000          WHEN "35"  MOVE  8 TO RC MOVE L35 TO FSN-LIB
012100          WHEN "37"  MOVE  8 TO RC MOVE L37 TO FSN-LIB
012200          WHEN "38"  MOVE  8 TO RC MOVE L38 TO FSN-LIB
012300          WHEN "39"  MOVE  8 TO RC MOVE L39 TO FSN-LIB
012400          WHEN "41"  MOVE  8 TO RC MOVE L41 TO FSN-LIB
012500          WHEN "42"  MOVE  8 TO RC MOVE L42 TO FSN-LIB
012600          WHEN "43"  MOVE  8 TO RC MOVE L43 TO FSN-LIB
012700          WHEN "44"  MOVE  8 TO RC MOVE L44 TO FSN-LIB
012800          WHEN "46"  MOVE  4 TO RC MOVE L46 TO FSN-LIB
012900          WHEN "47"  MOVE  8 TO RC MOVE L47 TO FSN-LIB
013000          WHEN "48"  MOVE  8 TO RC MOVE L48 TO FSN-LIB
013100          WHEN "49"  MOVE  8 TO RC MOVE L49 TO FSN-LIB
013200          WHEN OTHER MOVE 16 TO RC MOVE LXX TO FSN-LIB
013300     END-EVALUATE.
013400     IF FS NOT = "00"  AND NOT = "10"
013500        DISPLAY "*****GESTFST - "
013600                FN " - FILE STATUS=" FSN
013700     END-IF.
013800
013900*-----------------------------------------------------------------
014000*    Traitement fs etendu (9 en  1ere position du fs)
014100*-----------------------------------------------------------------
014200 TRAITEMENT-EXTENDED.
014300     MOVE 12                      TO RC.
014400     MOVE FSK2-BIN                TO FSE-COD.
014500     MOVE "CONSULTER LA BROCHURE" TO FSE-LIB.
014600     DISPLAY "*****GESTFST - "
014700             FN " - FILE STATUS=" FSE.
014800
014900*-----------------------------------------------------------------
015000*    Il est bien que cette instruction soit la derniere du pgm
015100*-----------------------------------------------------------------
015200 RETOUR. EXIT PROGRAM.
